#include "client.h"

Client::Client(char* ipaddr)
{
	sock = socket(PF_INET, SOCK_STREAM, 0);

	if(sock == -1)
		error_handling("socket() error");

	memset(&serv_addr, 0, sizeof(serv_addr));

	// 서버 주소 설정
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = inet_addr(ipaddr);
	serv_addr.sin_port = htons(PORT);

	// 서버와 연결
	if(connect(sock, (struct sockaddr*)&serv_addr, sizeof(serv_addr)) == -1)
		error_handling("connect() error!");
}

Client::~Client()
{
	close(sock);
}

int Client::receiveImage()
{
	int buf[BUFSIZE];
	char signal[10];


	int size = 0;
	int filesize = 0;
	int i=1;

	signal[0]='O';
	signal[1]='K';
	

	if((fd_image = open("screen.png", O_CREAT | O_TRUNC | O_RDWR, 0644)) == -1)
	{
		perror("open failed");
		exit(1);
	}


	while(1)
	{
		size = read(sock, buf, BUFSIZE);
#ifdef DEBUG
		printf("%d : recieved size: %d\n", i, size);
#endif
		write(fd_image, buf, size);
		write(sock,signal,2);
	
		filesize += size;
		i++;

		if(size<BUFSIZE)
			break;
	}

#ifdef DEBUG
	printf("File Recieved Success.\n");
	printf("Recieved File Size: %d bytes\n", filesize);
#endif

	close(fd_image);


	write(sock,signal,2);
	return 0;
}

void Client::error_handling(char *message)
{
	fputs(message, stderr);
	fputc('\n',stderr);
}

