#include "server.h"

Server::Server()
{
	isExcute = false;
}

int Server::Init()
{
	int option;

	if(isExcute)
		return 0;


	// Socket 
	option=true;
	serv_sock = socket(PF_INET, SOCK_STREAM, 0);
	setsockopt(serv_sock, SOL_SOCKET, SO_REUSEADDR, &option, sizeof(option));

	if(serv_sock == -1)
	{
		error_handling("socket() error");
		return -1;
	}
	
	// 서버 주소 구조체 초기화
	memset(&serv_addr, 0, sizeof(serv_addr));
	

	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
	serv_addr.sin_port = htons(PORT);

	// Bind
	if(bind(serv_sock, (struct sockaddr*) &serv_addr, sizeof(serv_addr)) == -1)
	{
		error_handling("bind() error");
		return -1;
	}

	// Listen
	if(listen(serv_sock, 5) == -1)
	{
		error_handling("listen() error");
		return -1;
	}

	clnt_addr_size = sizeof(clnt_addr);

	// Accept
	clnt_sock = accept(serv_sock, (struct sockaddr*)&clnt_addr, (socklen_t*)&clnt_addr_size);
	
	if(clnt_sock == -1)
	{
		error_handling("accept() error");
		return -1;
	}

	isExcute = true;
	return 0;
}

int Server::Exit()
{
	int ret;

	close(clnt_sock);	
	ret = close(serv_sock);	
	
	if(ret == 0)
		isExcute = false;

	return ret;
}

Server::~Server()
{

}

int Server::transferImage()					// NEED: 파일 이름을 인자를 통한 방법? (재사용성)
{
	char 	buf[BUFSIZE];
	char	signal[10];
	
	int 		size;			// 전송 크기
	int		transfersize;		// 전체 전송 크기
	int		i;

	if((fd_image = open( "screen.png", O_RDWR ))==-1)		// NEED: 파일이름 유동적으로 만들기..
	{
		perror("open failed");
		return -1;
	}

	i=1;
	transfersize=0;
	size=0;

	while((size = read(fd_image, buf, BUFSIZE)) > 0)
	{
#ifdef DEBUG
		printf("%d : transfered size: %d\n", i, size);
#endif
		write(clnt_sock, buf, size);
		read(clnt_sock,signal,2);
		if(signal[0]=='O'&&signal[1]=='K')
		{
			transfersize += size;
			i++;
			signal[0]=signal[1]=0;
		}
		else
			break;
	}

#ifdef DEBUG
	printf("File Transfer Success.\n");
	printf("Transfered File Size: %d bytes\n", transfersize);
#endif

	close(fd_image);		// 이미지 파일 닫기

	read(clnt_sock,	signal,2);	// 모두 받았다는 확인 기다림.
	if(signal[0]=='O'&&signal[1]=='K')
		return 0;
	else
		return -1;
}

void Server::error_handling(char *message)
{
	fputs(message, stderr);
	fputc('\n',stderr);
}

